/*Compilation line: gcc pr2a.c -lm
which creates a.out
or gcc -c pr2a.c 
creating an object file pr2a.o and then
gcc pr2a.o -lm
which creates a.out (if no errors) 
Execution: ./a.out 10000 -2
****************************/
#include<stdio.h>
#include<math.h>
#include<stdlib.h>

int main(int argc,char **argv){
 unsigned int N=1,k;
 double p,s,s1;
 if(argc>2){
  p=atof(argv[2]);
  N=atoi(argv[1]);
 }else{ 
  printf("Only %d<3 parameters to the program. Terminating.\n",argc);
  return 1;
 }
 printf("File %s parameters are N=%d p=%g\n",argv[0],N,p);
 s=0;
 for(k=1;k<=N;k++)
   s+=pow(k,p);

 s1=0;k=1;
 while(k<=N)
  s1+=pow(k++,p);
 printf("The series sum 1 to %d k^(%g) equals %e = %e\n",N,p,s,s1); 
 return(0);
 
} /*main()*/

