/*Compilation line: gcc pr3.c 
which creates a.out
or gcc -c pr3.c 
creating an object file pr1.o and then
gcc pr3.o 
which creates a.out (if no errors) 
Execution: ./a.out 
****************************/
#include<stdio.h>

void main(void){
 int N=5,k;
 double x[5]={1,1/3.0,3.1,-0.23,134.5},y[5],z[5];
 FILE *ft=NULL,*fb=NULL;
 char tf[10],bf[10];
 printf("Give me the name of the text and binary files \n");
 scanf("%s %s",tf,bf);
 printf("Text file %s Binary file %s\n",tf,bf);
 
 printf("Before writing/reading\n");
 for(k=0;k<N;k++){
  y[k]=z[k]=0.0;
  printf("k=%d x[k]=%g y[k]=%g z[k]=%g\n",k,x[k],y[k],z[k]);
 }
 ft=fopen(tf,"w");
 if(!(ft==NULL)){
  for(k=0;k<N;k++)
   fprintf(ft,"%f ",x[k]);
  fclose(ft);
 }else{
  printf("File %s not opened for writing \n",tf);
 }

 fb=fopen(bf,"w");
 if(!(fb==NULL)){
  fwrite(x,sizeof(double),N,fb);
  fclose(fb);
 }else{
  printf("File %s not opened for writing\n",bf);
 }
 
 /*reading back to y and z */
 
 ft=fopen(tf,"r");
 if(!(ft==NULL)){
  for(k=0;k<N;k++)
   fscanf(ft,"%lf ",y+k);
  fclose(ft);
 }else{
  printf("File %s not opened for reading\n",tf);
 }

 fb=fopen(bf,"r");
 if(!(fb==NULL)){
  fread(z,sizeof(double),N,fb);
  fclose(fb);
 }else{
  printf("File %s not opened for reading\n",bf);
 }
 printf("After writing reading..\n"); 
 for(k=0;k<N;k++)
  printf("k=%d \t x[k]=%g \t y[k]=%g \t z[k]=%g\n",k,x[k],y[k],z[k]);
 
 printf("\nDifferences?\n");
 for(k=0;k<N;k++)
  printf("k=%d \t (x-y)[k]=%g (x-z)[k]=%g\n",k,x[k]-y[k],x[k]-z[k]);
 
 printf("Note that for k=1 x[1]!=y[1]. WHY??? \n");
 return;

} /*main()*/

